/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file           : main.c
  * @brief          : Main program body
  ******************************************************************************
  * @attention
  *
  * <h2><center>&copy; Copyright (c) 2021 STMicroelectronics.
  * All rights reserved.</center></h2>
  *
  * This software component is licensed by ST under BSD 3-Clause license,
  * the "License"; You may not use this file except in compliance with the
  * License. You may obtain a copy of the License at:
  *                        opensource.org/licenses/BSD-3-Clause
  *
  ******************************************************************************
  */
/* USER CODE END Header */
/* Includes ------------------------------------------------------------------*/

#include "main.h"
#include "dfsdm.h"
#include "dma.h"
#include "fatfs.h"
#include "quadspi.h"
#include "usb_device.h"
#include "gpio.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
#include "audioFunctions.h"
#include "math.h"
#include "arm_math.h"
//#include <../../Drivers/BSP/stm32l476g_discovery_glass_lcd.h>
/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */

/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */
/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/

/* USER CODE BEGIN PV */
//FIL                       File;
//FATFS                     FatFs;

#define AUDIO_BUF 1024
int32_t RecBuff[AUDIO_BUF];
int32_t PlayBuff [AUDIO_BUF];
#define SaturaLH(N, L, H) (((N)<(L))?(L):(((N)>(H))?(H):(N)))
int i=0;
int counter=0;
uint32_t                     DmaRecHalfBuffCplt  = 0;
uint32_t                     DmaRecBuffCplt      = 0;

/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);
/* USER CODE BEGIN PFP */

/* USER CODE END PFP */

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */

/* USER CODE END 0 */

/**
  * @brief  The application entry point.
  * @retval int
  */
int main(void)
{
  /* USER CODE BEGIN 1 */

  /* USER CODE END 1 */

  /* MCU Configuration--------------------------------------------------------*/

  /* Reset of all peripherals, Initializes the Flash interface and the Systick. */
  HAL_Init();

  /* USER CODE BEGIN Init */

  /* USER CODE END Init */

  /* Configure the system clock */
  SystemClock_Config();

  /* USER CODE BEGIN SysInit */

  /* USER CODE END SysInit */

  /* Initialize all configured peripherals */
  MX_GPIO_Init();
  MX_DMA_Init();
  MX_QUADSPI_Init();
  MX_USB_DEVICE_Init();
  MX_FATFS_Init();
  MX_DFSDM1_Init();
  /* USER CODE BEGIN 2 */


















//f_mount(&FatFs, (TCHAR const*)USERPath, 1);

  FATFS fs;           /* File system object */
      FIL fil;            /* File object */
      FRESULT res;        /* API result code */
      UINT bw;            /* Bytes written */
      BYTE work[_MAX_SS]; /* Work area (larger is better for processing time) */

      /* Create FAT volume */
          res = f_mkfs("", FM_ANY, 0, work, sizeof work);
          if (res) {}

          /* Register work area */
          f_mount(&fs, "", 0);

          /* Create a file as new */
          res = f_open(&fil, "hello.txt", FA_CREATE_NEW | FA_WRITE);
          if (res) {}
int32_t MyVariable = 0x00abcdef;
          /* Write a message */
          f_write(&fil, "Hello, World!\r\n", 15, &bw);
          if (bw != 15) {}
          f_write(&fil, &MyVariable, 3, &bw);
          /* Close the file */
          f_close(&fil);

          /* Unregister work area */
         // f_mount(0, "", 0);

          res = f_open(&fil, "number.wav", FA_CREATE_NEW | FA_WRITE);
int8_t ch_x;
int32_t temp1;
Wave_Audio_Header();
f_write(&fil, &WavHeaderBuffer, 44, &bw);

HAL_DFSDM_FilterRegularStart_DMA(&hdfsdm1_filter0, (int32_t *)RecBuff , AUDIO_BUF);

//char *ptr;
HAL_GPIO_WritePin(LED_GREEN_GPIO_Port, LED_GREEN_Pin, 1);
  /* USER CODE END 2 */

  /* Infinite loop */
  /* USER CODE BEGIN WHILE */
  while (1)
  {
//	  ch_x ='a';
//	  do{
//	  f_write(&fil, &ch_x, 1, &bw);
//	  HAL_Delay(100);
//	  ch_x++;
//	  }while(ch_x < 'z');
//	  f_close(&fil);
//	  f_mount(0, "", 0);
    /* USER CODE END WHILE */

    /* USER CODE BEGIN 3 */
	  if(DmaRecHalfBuffCplt == 1)
	     {
	       /* Store values on Play buff */
	       for(i = 0; i < AUDIO_BUF/2; i++)
	       {
	    	   PlayBuff[i] = RecBuff[i] >> 8;
	//         PlayBuff[i]     = SaturaLH((RecBuff[i] >> 8), -32768, 32767);
	         f_write(&fil, &PlayBuff[i], 3, &bw);
	    //     PlayBuff[(2*i)+1] = PlayBuff[2*i];
//	    	   PlayBuff[i] = RecBuff[i] >> 8;


//	    	   ch_x = PlayBuff[i];
//	    	   f_write(&fil, &ch_x, 1, &bw);
//	    	   ch_x = PlayBuff[i] >> 8;
//	    	   f_write(&fil, &ch_x, 1, &bw);
//	    	   ch_x = PlayBuff[i] >> 8;
//	    	   f_write(&fil, &ch_x, 1, &bw);
//
	         //ch_x = 0x00;
//	    	   f_write(&fil, &ch_x, 1, &bw);
//	    	   f_write(&fil, &ch_x, 1, &bw);
//	    	   f_write(&fil, &ch_x, 1, &bw);
	       }
//	       temp1 = PlayBuff[0];
//ch_x = temp1;
//ch_x = temp1 >> 8;
//ch_x = temp1 >> 8*2;
//ch_x = temp1 >> 8*3;
//asm("nop");
	       //f_write(&fil, &PlayBuff, (AUDIO_BUF*3), &bw);


//	       if(PlaybackStarted == 0)
//	       {
//	         if(0 != audio_drv->Play(AUDIO_I2C_ADDRESS, (uint16_t *) &PlayBuff[0], 4096))
//	         {
//	           Error_Handler();
//	         }
//	         if(HAL_OK != HAL_SAI_Transmit_DMA(&SaiHandle, (uint8_t *) &PlayBuff[0], 4096))
//	         {
//	           Error_Handler();
//	         }
//	         PlaybackStarted = 1;
//	       }
	       DmaRecHalfBuffCplt  = 0;
	     }
	  if(DmaRecBuffCplt == 1)
	     {
	       /* Store values on Play buff */
	       for(i = AUDIO_BUF/2; i < AUDIO_BUF; i++)
	       {
	    	   PlayBuff[i] = RecBuff[i] >> 8;
//    	   PlayBuff[i]     = SaturaLH((RecBuff[i] >> 8), -32768, 32767);
	    	  	         f_write(&fil, &PlayBuff[i], 3, &bw);
	    	 /*
	         ch_x = PlayBuff[i];
	         	    	   f_write(&fil, &ch_x, 1, &bw);
	         	    	   ch_x = PlayBuff[i] >> 8;
	         	    	   f_write(&fil, &ch_x, 1, &bw);
	         	    	   ch_x = PlayBuff[i] >> 8;
	         	    	  f_write(&fil, &ch_x, 1, &bw);

	         	*/
//	         	    	  ch_x = 0x00;
//	         	    	  	    	   f_write(&fil, &ch_x, 1, &bw);
//	         	    	  	    	   f_write(&fil, &ch_x, 1, &bw);
//	         	    	  	    	   f_write(&fil, &ch_x, 1, &bw);
	     //    PlayBuff[(2*i)+1] = PlayBuff[2*i];

	       }

	       counter++;
	    //   f_write(&fil, &PlayBuff, AUDIO_BUF*4, &bw);
	       if(counter == 1000)//200
	       {
	    	   HAL_GPIO_TogglePin(LED_GREEN_GPIO_Port, LED_GREEN_Pin);

	       f_close(&fil);
	       f_rename("number.wav", "song.wav");
	       f_mount(0, "", 0);
	       HAL_Delay(1000);
	       }

	       DmaRecBuffCplt  = 0;
	     }
  }
  /* USER CODE END 3 */
}

/**
  * @brief System Clock Configuration
  * @retval None
  */
void SystemClock_Config(void)
{
  RCC_OscInitTypeDef RCC_OscInitStruct = {0};
  RCC_ClkInitTypeDef RCC_ClkInitStruct = {0};
  RCC_PeriphCLKInitTypeDef PeriphClkInit = {0};

  /** Configure LSE Drive Capability
  */
  HAL_PWR_EnableBkUpAccess();
  __HAL_RCC_LSEDRIVE_CONFIG(RCC_LSEDRIVE_LOW);
  /** Initializes the RCC Oscillators according to the specified parameters
  * in the RCC_OscInitTypeDef structure.
  */
  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_LSE|RCC_OSCILLATORTYPE_MSI;
  RCC_OscInitStruct.LSEState = RCC_LSE_ON;
  RCC_OscInitStruct.MSIState = RCC_MSI_ON;
  RCC_OscInitStruct.MSICalibrationValue = 0;
  RCC_OscInitStruct.MSIClockRange = RCC_MSIRANGE_6;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_MSI;
  RCC_OscInitStruct.PLL.PLLM = 1;
  RCC_OscInitStruct.PLL.PLLN = 40;
  RCC_OscInitStruct.PLL.PLLP = RCC_PLLP_DIV7;
  RCC_OscInitStruct.PLL.PLLQ = RCC_PLLQ_DIV2;
  RCC_OscInitStruct.PLL.PLLR = RCC_PLLR_DIV2;
  if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
  {
    Error_Handler();
  }
  /** Initializes the CPU, AHB and APB buses clocks
  */
  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
                              |RCC_CLOCKTYPE_PCLK1|RCC_CLOCKTYPE_PCLK2;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV1;
  RCC_ClkInitStruct.APB2CLKDivider = RCC_HCLK_DIV1;

  if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_4) != HAL_OK)
  {
    Error_Handler();
  }
  PeriphClkInit.PeriphClockSelection = RCC_PERIPHCLK_DFSDM1|RCC_PERIPHCLK_USB;
  PeriphClkInit.Dfsdm1ClockSelection = RCC_DFSDM1CLKSOURCE_PCLK;
  PeriphClkInit.UsbClockSelection = RCC_USBCLKSOURCE_PLLSAI1;
  PeriphClkInit.PLLSAI1.PLLSAI1Source = RCC_PLLSOURCE_MSI;
  PeriphClkInit.PLLSAI1.PLLSAI1M = 1;
  PeriphClkInit.PLLSAI1.PLLSAI1N = 24;
  PeriphClkInit.PLLSAI1.PLLSAI1P = RCC_PLLP_DIV7;
  PeriphClkInit.PLLSAI1.PLLSAI1Q = RCC_PLLQ_DIV2;
  PeriphClkInit.PLLSAI1.PLLSAI1R = RCC_PLLR_DIV2;
  PeriphClkInit.PLLSAI1.PLLSAI1ClockOut = RCC_PLLSAI1_48M2CLK;
  if (HAL_RCCEx_PeriphCLKConfig(&PeriphClkInit) != HAL_OK)
  {
    Error_Handler();
  }
  /** Configure the main internal regulator output voltage
  */
  if (HAL_PWREx_ControlVoltageScaling(PWR_REGULATOR_VOLTAGE_SCALE1) != HAL_OK)
  {
    Error_Handler();
  }
  /** Enable MSI Auto calibration
  */
  HAL_RCCEx_EnableMSIPLLMode();
}

/* USER CODE BEGIN 4 */
/**
  * @brief  Half regular conversion complete callback.
  * @param  hdfsdm_filter : DFSDM filter handle.
  * @retval None
  */
void HAL_DFSDM_FilterRegConvHalfCpltCallback(DFSDM_Filter_HandleTypeDef *hdfsdm_filter)
{
  DmaRecHalfBuffCplt = 1;
}

/**
  * @brief  Regular conversion complete callback.
  * @note   In interrupt mode, user has to read conversion value in this function
            using HAL_DFSDM_FilterGetRegularValue.
  * @param  hdfsdm_filter : DFSDM filter handle.
  * @retval None
  */
void HAL_DFSDM_FilterRegConvCpltCallback(DFSDM_Filter_HandleTypeDef *hdfsdm_filter)
{
  DmaRecBuffCplt = 1;
}
/* USER CODE END 4 */

/**
  * @brief  This function is executed in case of error occurrence.
  * @retval None
  */
void Error_Handler(void)
{
  /* USER CODE BEGIN Error_Handler_Debug */
  /* User can add his own implementation to report the HAL error return state */
  __disable_irq();
  while (1)
  {
  }
  /* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
